/*

*/
#include <stdio.h>
#include <math.h>

#if defined _WIN32 || defined _WIN64
#  include <windows.h>
#endif

#ifdef __APPLE__
#  include <GLUT/glut.h>
#else
#  include <GL/glut.h>
#endif

int windowHeight;   // this is set by the glut reshape() callback function
int windowWidth;    // this is set by the glut reshape() callback function

#define box1Length 15.0
#define box2Length  6.0
#define box3Length  4.0
#define box4Length  3.0
#define box5Length  2.0
#define box6Length  1.0

float boxLength[] = {-1.0, box1Length, box2Length, box3Length, box4Length, box5Length, box6Length};

float boxColor[][3] = { {-1.0, -1.0, -1.0},  // not used
                        {1.0, 0.0, 0.0},
                        {0.0, 1.0, 0.0},
                        {0.0, 0.0, 1.0},
                        {1.0, 0.0, 1.0},
                        {1.0, 1.0, 0.0},
                        {0.0, 1.0, 1.0} };

float boxHorz[] = {-1.0, 0.0, 0.0, box2Length, 0.0, 0.0, 0.0};

int boxNumber = 0;  // 0 denotes a non existent box

int mouseDownX;

void box1();
void box2();
void box3();
void box4();
void box5();
void box6();
void drawBox(int);

/* Prototypes for the GLUT callback functions */
void display( void );
void reshape(int, int);
void mouse(int, int, int, int);
void motion(int, int);

int main(int argc, char** argv)
{
   /* Standard GLUT initialization */
   glutInit(&argc,argv);
   glutInitDisplayMode (GLUT_DOUBLE | GLUT_RGB);
   glutInitWindowSize(800, 400);
   glutInitWindowPosition(100, 100);
   glutCreateWindow("Problem 1");
   glutDisplayFunc(display);
   glutReshapeFunc(reshape);
   glutMouseFunc(mouse);
   glutMotionFunc(motion);

   /* Initialize OpenGL state */
   glClearColor(1.0, 1.0, 1.0, 1.0);  /* white background */

   /* Enter event loop */
   glutMainLoop();

   return 0;  /* we never get here */
}//main()


void box1()
{
   drawBox(1);


}//box1()


void box2()
{
   drawBox(2);


}//box2()


void box3()
{
   drawBox(3);


}//box3()


void box4()
{
   drawBox(4);


}//box4()


void box5()
{
   drawBox(5);
}//box5()


void box6()
{
   drawBox(6);
}//box6()


void drawBox(int boxNumber)
{
   glColor3fv( boxColor[boxNumber] );

   glBegin(GL_QUADS);
     glVertex2f( 0.0, 0.0);
     glVertex2f(boxLength[boxNumber], 0.0);
     glVertex2f(boxLength[boxNumber], 1.0);
     glVertex2f( 0.0, 1.0);
   glEnd();
}//drawBox()


/* The display() callback function */
void display( void )
{
   glClear(GL_COLOR_BUFFER_BIT); /* clear the window */

   // viewport
   glViewport(0, 0, windowWidth, windowHeight);

   /* set up viewing */
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluOrtho2D(0.0, 20.0, 0.0, 10.0); /* world window */

   /* draw the image for this viewport */
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();



   box1();



   glutSwapBuffers();
   printf("We got a \"display()\" event\n");
}//display()


/* The reshape() callback function */
void reshape(int width, int height)
{
   windowWidth  = width;
   windowHeight = height;

   printf("We got a \"reshape(%d, %d)\" event\n", width, height);
   glutPostRedisplay();
}//reshape()


/* The mouse() callback function */
void mouse(int button, int state, int x, int y)
{



   printf("We got a \"mouse(%d, %d, %d, %d)\" event\n", button, state, x, y);
}//mouse()


/* The mouse motion() callback function */
void motion(int x, int y)
{




   printf("We got a \"motion(%d, %d)\" event\n", x, y);
   glutPostRedisplay();
}//motion()
